; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Cube foldable maker
; Copyright (c) 2008 Justin Barca
; justinbarca@gmail.com
;
;       
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(define (script-fu-doedecahedron-foldable image
                                 drawable                                                             
                               )
  (let* ((face01 0)(face02 0)(face03 0)(face04 0)(face05 0) (face06 0) (face07 0) (face08 0) (face09 0) (face10 0) (face11 0) (pent-size 0) (bottom-gap 0) (face-rad-dist 0) (pent-rad 0) (face-rad-dist 0) (face-length 0) (cur-ang 0) (pi 0)
       )

    (gimp-context-push)

    (gimp-image-undo-group-start image)
    (set! pi 3.14159265)
    (set! pent-rad (/ (car(gimp-image-width image)) 2))
    (set! face-rad-dist (* (sin (* (/ 54 360) 2 pi)) pent-rad))
    (set! face-length (* (cos (* (/ 54 360) 2 pi)) pent-rad 2))
  
  
  
    (gimp-image-resize image (* 12 pent-rad) (* 8 pent-rad) (* 8 pent-rad) (* 4 pent-rad) )

    (set! face01 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face01 -1)
    (set! cur-ang (* (/ 0 360) 2 pi) )
    (gimp-selection-none image)
    (set! face01 (car (gimp-drawable-transform-rotate-simple face01 1 1 0 0 0 )))
    (gimp-layer-translate face01 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))

    (set! face02 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face02 -1)
    (set! cur-ang (* (/ 72 360) 2 pi) )
    (gimp-selection-none image)
    (set! face02 (car (gimp-drawable-transform-rotate-simple face02 1 1 0 0 0 )))
    (gimp-layer-translate face02 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face03 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face03 -1)
    (set! cur-ang (* (/ 144 360) 2 pi) )
    (gimp-selection-none image)
    (set! face02 (car (gimp-drawable-transform-rotate-simple face03 1 1 0 0 0 )))
    (gimp-layer-translate face03 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face04 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face04 -1)
    (set! cur-ang (* (/ 216 360) 2 pi) )
    (gimp-selection-none image)
    (set! face04 (car (gimp-drawable-transform-rotate-simple face04 1 1 0 0 0 )))
    (gimp-layer-translate face04 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face05 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face05 -1)
    (set! cur-ang (* (/ 288 360) 2 pi) )
    (gimp-selection-none image)
    (set! face05 (car (gimp-drawable-transform-rotate-simple face05 1 1 0 0 0 )))
    (gimp-layer-translate face05 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face06 (car (gimp-layer-new-from-drawable face05 image)))
    (gimp-image-add-layer image face06 -1)
    (gimp-selection-none image)
    (set! face06 (car (gimp-drawable-transform-rotate-simple face06 1 1 0 0 0 )))
    (set! cur-ang (* (/ 252 360) 2 pi) )
    (gimp-layer-translate face06 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    
    
    (set! face07 (car (gimp-layer-new-from-drawable face06 image)))
    (gimp-image-add-layer image face07 -1)
    (set! cur-ang (* (/ 288 360) 2 pi) )
    (gimp-selection-none image)
    (set! face07 (car (gimp-drawable-transform-rotate-simple face07 1 1 0 0 0 )))
    (gimp-layer-translate face07 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
           
    (set! face08 (car (gimp-layer-new-from-drawable face07 image)))
    (gimp-image-add-layer image face08 -1)
    (set! cur-ang (* (/ 36 360) 2 pi) )
    (gimp-selection-none image)
    (set! face08 (car (gimp-drawable-transform-rotate-simple face08 1 1 0 0 0 )))
    (gimp-layer-translate face08 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face09 (car (gimp-layer-new-from-drawable face07 image)))
    (gimp-image-add-layer image face09 -1)
    (set! cur-ang (* (/ 180 360) 2 pi) )
    (gimp-selection-none image)
    (set! face09 (car (gimp-drawable-transform-rotate-simple face09 1 1 0 0 0 )))
    (gimp-layer-translate face09 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face10 (car (gimp-layer-new-from-drawable face07 image)))
    (gimp-image-add-layer image face10 -1)
    (set! cur-ang (* (/ 252 360) 2 pi) )
    (gimp-selection-none image)
    (set! face10 (car (gimp-drawable-transform-rotate-simple face10 1 1 0 0 0 )))
    (gimp-layer-translate face10 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face11 (car (gimp-layer-new-from-drawable face07 image)))
    (gimp-image-add-layer image face11 -1)
    (set! cur-ang (* (/ 324 360) 2 pi) )
    (gimp-selection-none image)
    (set! face11 (car (gimp-drawable-transform-rotate-simple face11 1 1 0 0 0 )))
    (gimp-layer-translate face11 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    (set! drawable (car (gimp-image-merge-visible-layers image 1)))
    (plug-in-autocrop 1 image drawable)
    
    

    
;  (set! face03 (car (gimp-layer-new-from-drawable drawable image)))
;  (gimp-image-add-layer image face03 -1)
;  (set! cur-ang  (* (/ 144 360) 2 pi) )
;  (gimp-layer-translate face03 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
;  ;  (gimp-floating-sel-anchor (car (gimp-image-get-floating-sel image)))
;  ;(gimp-image-set-active-layer image face03)
;  (gimp-selection-all image)
;  (gimp-drawable-transform-rotate-default face03 180 1 0 0 0 0)
;  
;  (set! face04 (car (gimp-layer-new-from-drawable drawable image)))
;  (gimp-image-add-layer image face04 -1) 
;  (set! cur-ang  (* (/ 216 360) 2 pi) )
;  (gimp-layer-translate face04 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
;  ;  (gimp-floating-sel-anchor (car (gimp-image-get-floating-sel image)))
;  ;(gimp-image-set-active-layer image face04)
;  (gimp-selection-all image)
;  (gimp-drawable-transform-rotate-default face04 180 1 0 0 0 0)
;  
;  
;  (set! face05 (car (gimp-layer-new-from-drawable drawable image)))
;  (gimp-image-add-layer image face05 -1) 
;  (set! cur-ang  (* (/ 288 360) 2 pi) )
;  (gimp-layer-translate face05 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
;  ;(gimp-floating-sel-anchor (car (gimp-image-get-floating-sel image)))
;  ;(gimp-image-set-active-layer image face05)
;  (gimp-selection-all image)
;  (gimp-drawable-transform-rotate-default face05 180 1 0 0 0 0)
;  
;  
 
  
  
  
    (gimp-image-undo-group-end image)
    (gimp-displays-flush)

    (gimp-context-pop)
  )
)

(script-fu-register "script-fu-doedecahedron-foldable"
  _"_Doedecahdron"
  _"Make a shape that can be folded into a doedecahedron with images of current layer as faces"
  "Justin Barca <justinbarca@gmail.com>"
  "Justin Barca"
  "2008/03/13"
  "RGB* GRAY*"
  SF-IMAGE      "Image"           0
  SF-DRAWABLE   "Drawable"        0
  
)

(script-fu-menu-register "script-fu-doedecahedron-foldable"
                         "<Image>/Filters/Render/Foldables")
