; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Icosahdron foldable maker
; Copyright (c) 2008 Justin Barca
; justinbarca@gmail.com
;
;       
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(define (script-fu-icosahedron-foldable image
                                 drawable                                                             
                               )
  (let* ((face01-01 0)(face01-02 0) (face01-03 0) (face01-04 0) (face02-01 0) (face02-02 0) (face02-03 0) (face02-04 0) (face02-05 0) (face03-01 0) (face03-02 0) (face03-03 0) (face03-04 0) (face03-05 0) (face04-01 0) (face04-02 0) (face04-03 0) (face04-04 0) (face04-05 0) (face-rad-dist 0) (tri-rad 0) (face-length 0) (cur-ang 0) (pi 0)
       )

    (gimp-context-push)

    (gimp-image-undo-group-start image)
    (set! pi 3.14159265)
    (set! tri-rad (/ (car(gimp-image-width image)) 2))
    (set! face-rad-dist (* (cos (* (/ 60 360) 2 pi)) tri-rad))
    (set! face-length (* 2 (* (sin (* (/ 60 360) 2 pi)) tri-rad)))
    
    
    
  
    (gimp-image-resize image (* 6 face-length ) (* 5 tri-rad) 0 0 )

    (set! face01-01 (car (gimp-layer-new-from-drawable drawable image)))
    (gimp-image-add-layer image face01-01 -1)
    (gimp-layer-translate face01-01 face-length 0)
    
    (set! face01-02 (car (gimp-layer-new-from-drawable   face01-01 image)))
    (gimp-image-add-layer image face01-02 -1)
    (gimp-layer-translate face01-02 face-length 0)
    
    (set! face01-03 (car (gimp-layer-new-from-drawable face01-02 image)))
    (gimp-image-add-layer image face01-03 -1)
    (gimp-layer-translate face01-03 face-length 0)
    
    (set! face01-04 (car (gimp-layer-new-from-drawable face01-03 image)))
    (gimp-image-add-layer image face01-04 -1)
    (gimp-layer-translate face01-04 face-length 0)

    (set! face02-01 (car (gimp-layer-new-from-drawable drawable image )))
    (gimp-image-add-layer image face02-01 -1)
    (set! cur-ang (* (/ 0 360) 2 pi) )
    (gimp-selection-none image)
    (set! face02-01 (car (gimp-drawable-transform-rotate-simple face02-01 1 1 0 0 0 )))
    (gimp-layer-translate face02-01 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face02-02 (car (gimp-layer-new-from-drawable face02-01 image )))
    (gimp-image-add-layer image face02-02 -1)
    (gimp-layer-translate face02-02 face-length 0)
    
    (set! face02-03 (car (gimp-layer-new-from-drawable face02-02 image )))
    (gimp-image-add-layer image face02-03 -1)
    (gimp-layer-translate face02-03 face-length 0)
    
    (set! face02-04 (car (gimp-layer-new-from-drawable face02-03 image )))
    (gimp-image-add-layer image face02-04 -1)
    (gimp-layer-translate face02-04 face-length 0)
    
    (set! face02-05 (car (gimp-layer-new-from-drawable face02-04 image )))
    (gimp-image-add-layer image face02-05 -1)
    (gimp-layer-translate face02-05 face-length 0)
    
    (set! face03-01 (car (gimp-layer-new-from-drawable face02-01 image )))
    (gimp-image-add-layer image face03-01 -1)
    (set! cur-ang (* (/ 60 360) 2 pi) )
    (gimp-selection-none image)
    (set! face03-01 (car (gimp-drawable-transform-rotate-simple face03-01 1 1 0 0 0 )))
    (gimp-layer-translate face03-01 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face03-02 (car (gimp-layer-new-from-drawable face03-01 image )))
    (gimp-image-add-layer image face03-02 -1)
    (gimp-layer-translate face03-02 face-length 0)
    
    (set! face03-03 (car (gimp-layer-new-from-drawable face03-02 image )))
    (gimp-image-add-layer image face03-03 -1)
    (gimp-layer-translate face03-03 face-length 0)
    
    (set! face03-04 (car (gimp-layer-new-from-drawable face03-03 image )))
    (gimp-image-add-layer image face03-04 -1)
    (gimp-layer-translate face03-04 face-length 0)
    
    (set! face03-05 (car (gimp-layer-new-from-drawable face03-04 image )))
    (gimp-image-add-layer image face03-05 -1)
    (gimp-layer-translate face03-05 face-length 0)
    
    (set! face04-01 (car (gimp-layer-new-from-drawable face03-01 image )))
    (gimp-image-add-layer image face04-01 -1)
    (set! cur-ang (* (/ 0 360) 2 pi) )
    (gimp-selection-none image)
    (set! face04-01 (car (gimp-drawable-transform-rotate-simple face04-01 1 1 0 0 0 )))
    (gimp-layer-translate face04-01 (* (sin cur-ang) 2 face-rad-dist) (* (cos cur-ang) 2 face-rad-dist))
    
    (set! face04-02 (car (gimp-layer-new-from-drawable face04-01 image)))
    (gimp-image-add-layer image face04-02 -1)
    (gimp-layer-translate face04-02 face-length 0)
    
    (set! face04-03 (car (gimp-layer-new-from-drawable face04-02 image)))
    (gimp-image-add-layer image face04-03 -1)
    (gimp-layer-translate face04-03 face-length 0)
    
    (set! face04-04 (car (gimp-layer-new-from-drawable face04-03 image)))
    (gimp-image-add-layer image face04-04 -1)
    (gimp-layer-translate face04-04 face-length 0)
    
    (set! face04-05 (car (gimp-layer-new-from-drawable face04-04 image)))
    (gimp-image-add-layer image face04-05 -1)
    (gimp-layer-translate face04-05 face-length 0)
    
    (set! drawable (car (gimp-image-merge-visible-layers image 1)))
    (plug-in-autocrop 1 image drawable)
  
    (gimp-image-undo-group-end image)
    (gimp-displays-flush)

    (gimp-context-pop)
  )
)

(script-fu-register "script-fu-icosahedron-foldable"
  _"_Icosahedron"
  _"Make a shape that can be folded into a icosahodron with images of current layer as faces"
  "Justin Barca <justinbarca@gmail.com>"
  "Justin Barca"
  "2008/03/13"
  "RGB* GRAY*"
  SF-IMAGE      "Image"           0
  SF-DRAWABLE   "Drawable"        0
  
)

(script-fu-menu-register "script-fu-icosahedron-foldable"
                         "<Image>/Filters/Render/Foldables")
